#!/bin/sh
#
#$Id: lv_info4hp.sh,v 1.13 2012/02/14 04:33:34 root Exp root $
#
# The following code is Confidential and is covered by the installation license
# Copyright 2004-2012 by Midrange Performance Group
#
#&& Used to gather logical volume information from a system.
#& Output tar file is /tmp/lv_info4hp.out_systemname

# This is NOT the usage of this script, but the usage for lsvg
# Usage: lsvg [-o] [[-L] -n PVname]
#        lsvg [-L] [-i] [-P] [-m] [-M | -l | -p] VGname...
# Lists the characteristics of a volume group.

jhost=`uname -n` 
jtype=`uname -s`

if [ "x${jtype}x" != "xHP-UXx" ]; then
   echo "This currently only gathers logical volume information on HP, exiting.
   "
   exit 1
fi

jdir="/tmp/lvinfo4hp/"

mkdir -p $jdir

cd $jdir

ioscan -funC disk  2>/dev/null > ioscan_-funC_disk_${jhost}.mpginc 
powermt display dev=all 2>/dev/null > powermt_display_dev=all_${jhost}.mpginc

awk '/rdsk/ {print $1"\n"$2"\n"$3}' ioscan_-funC_disk_${jhost}.mpginc  2>/dev/null | grep rdsk |while read vRdisk ; do
print ${vRdisk}"\t" $(diskinfo -b ${vRdisk})
done > diskinfo_${jhost}.mpginc

ioscan -F -m dsf 2>/dev/null > ioscan_-F_-m_dsf_${jhost}.mpginc

ioscan -F -m dsf 2>/dev/null | grep -v _ > ioscan_-F_-m_dsf_trimmed_${jhost}.mpginc

cat ioscan_-F_-m_dsf_trimmed_${jhost}.mpginc \
   | awk -F: '{print $1,$2}' \
   | while read jdisk vRdisk; do
        print "#========""\n"${jdisk}"\n"${vRdisk}"\n""#======= "
        diskinfo -v ${vRdisk}
     done > diskinfo2_${jhost}.mpginc

cat ioscan_-F_-m_dsf_trimmed_${jhost}.mpginc \
   | awk -F: '{print $1,$2}' \
   | while read jdisk vRdisk; do
        print "#========""\n"${jdisk}"\n"${vRdisk}"\n""#======= "
        scsimgr get_info -D ${jdisk} 2>/dev/null 
     done > scsimgr_get_info-D_diskno_${jhost}.mpginc

###   root_HP@MPG_aps39-80:/tmp/lvinfo4hp > grep "LUN path count" scsimgr_get_info-D_diskno_aps39-80.mpginc
###   LUN path count                                = 1

vgdisplay -v > vgdisplay_-v_${jhost}.mpginc

grep "LV Name"  vgdisplay_-v_${jhost}.mpginc | awk '{print $NF}' \
   | while read jlvname ; do
        print "#========""\n"${jlvname}"\n""#======= "
        lvdisplay -v ${jlvname} | awk '{if( $4 != "current" && $4 != "free" ) print $0}'
     done > lvdisplay_-v_lv_${jhost}.mpginc

# Because sometimes HP uses alternate links for PV Names
# Next line replaced with recommendations from Matt 
# grep "PV Name"  vgdisplay_-v_${jhost}.mpginc | awk '{print $NF}' \
awk '/PV Name/ && ! /Alternate Link/ {print $NF}' vgdisplay_-v_${jhost}.mpginc \
   | while read jpvname ; do
        print "#========""\n"${jpvname}"\n""#======= "
        pvdisplay -v ${jpvname} | awk '{if( $2 != "current" && $2 != "free" ) print $0}' | tee /tmp/jtmpfile.tmp 
	jpaths=`grep -c "PV Name"  /tmp/jtmpfile.tmp | awk '{print $1}'`
	print "PATH Count ${jpvname} ${jpaths}"
     done > pvdisplay_-v_pv_${jhost}.mpginc

# This is to identify the systems that have mirrored root disks
lvlnboot -v > lvlnboot_-v_${jhost}.mpginc

chmod 744 *

tar cvf /tmp/lv_info4hp_${jhost}.tar *.mpginc 2>/dev/null

chmod 744 /tmp/lv_info4hp_${jhost}.tar

gzip -f /tmp/lv_info4hp_${jhost}.tar

echo "Please send  /tmp/lv_info4hp_${jhost}.tar.gz to support@mpginc.com"
