#!/bin/ksh
#
# $Id: mpg_admin_info.sh,v 1.9 2012/04/18 02:44:41 root Exp $
#
# The following code is Confidential and is covered by the installation license
# Copyright 2004-2012 by Midrange Performance Group
#
#&& Script to gather administrator information (mpg_admin_info.sh)
#& Will gather assorted information for cpu and other hardware on linux or unix
#
#&@ Several other calls are made and if successful they will be gathered
#
#&% Ran to gather assorted system information.
#

jhost=`uname -n 2>/dev/null `
jproc=`uname -p 2>/dev/null `
if [ "x" = "x${jproc}" ] || [ "xunknown" = "x${jproc}" ]; then
   jproc=`uname -m 2>/dev/null`
fi
jrev=`uname -r 2>/dev/null `
jsys=`uname -s 2>/dev/null `
joutfile="/tmp/mpg_admin_info/mpginfo_${jhost}_${jproc}_${jsys}_${jrev}.tar" 
mkdir -p /tmp/mpg_admin_info

jcpuinfo () {
for jtest in a b c d e f g h i j k l m n o p q r s t u v w x y z
do  
   uname -${jtest} 2>/dev/null > /tmp/mpg_admin_info/uname.tmp
   if [ -s  /tmp/mpg_admin_info/uname.tmp ] ; then
       echo "uname -${jtest} (`cat /tmp/mpg_admin_info/uname.tmp`)"
   fi
done
echo ""

while 
read line
do
   $line 2>/dev/null > /tmp/mpg_admin_info.tmp
   if [ -s /tmp/mpg_admin_info.tmp ]; then
      echo "($line)"
      echo "#-------------------#"
      cat /tmp/mpg_admin_info.tmp
      echo "#------- end -------#"
      echo ""
   else
      echo "($line) [no output]"
      echo ""
   fi
done <<- mpginc
cat /etc/issue
grep ^processor /proc/cpuinfo
grep ^cpu /proc/cpuinfo
grep ^model /proc/cpuinfo
grep ^platform /proc/cpuinfo 
grep ^clock /proc/cpuinfo 2>/dev/null | sed -e "s,.00*M,\\\ M,"
grep ^clock /proc/cpuinfo
hostid
machid
hw
lsattr
lsblk
lsdev
lsmod
lspath
lspci
lspnp
lsscsi
lsusb
model
mpginc
# This did not work in the script
# grep ^clock /proc/cpuinfo 2>/dev/null | sed -e "s,.00*M,\ M,"

# If new commands need to be added, place them above mpginc.
# These commmands are ran regardless of system.
# This is for testing only.
# If output is know to be extremely large, place it below on its own file.

}

# This is the series of commmands above in one file
jcpuinfo > /tmp/mpg_admin_info/mpgmultiinfo_${jhost}.mpginc

# These commmands are ran regardless, since this is for testing only.
# Since each can be large, each gets its own file or 0 byte file if it does not work
dmidecode 2>/dev/null > /tmp/mpg_admin_info/mpgdmidecode_${jhost}.mpginc
hwinfo 2>/dev/null > /tmp/mpg_admin_info/mpghwinfo_${jhost}.mpginc
lscfg 2>/dev/null > /tmp/mpg_admin_info/mpglscfg_${jhost}.mpginc
machinfo 2>/dev/null > /tmp/mpg_admin_info/mpgmachinfo_${jhost}.mpginc
prtconf 2>/dev/null > /tmp/mpg_admin_info/mpgprtconf_${jhost}.mpginc
sysinfo 2>/dev/null > /tmp/mpg_admin_info/mpgsysinfo_${jhost}.mpginc

cd /tmp/mpg_admin_info
tar cvf ${joutfile} mpgmultiinfo_${jhost}.mpginc mpgdmidecode_${jhost}.mpginc mpghwinfo_${jhost}.mpginc mpglscfg_${jhost}.mpginc mpgmachinfo_${jhost}.mpginc mpgprtconf_${jhost}.mpginc mpgsysinfo_${jhost}.mpginc
gzip -f ${joutfile}
echo "Please send ${joutfile}.gz to support@mpginc.com!!!"



