#!/bin/ksh
#
# $Id: pn_scripts_info_mpg.sh,v 1.6 2012/04/12 03:48:18 root Exp $
#
# The following code is Confidential and is covered by the installation license
# Copyright 2004-2012 by Midrange Performance Group
#
#&& Used to create information files about all mpg scripts 
#
# Display the version number that is being ran
echo "Running `grep "\$\I\d\:" ${0} | awk '{print $3,$4,$5,$6}' ` "
#
#& Special comment lines used in scripts to allow auto documentaion:
#& #&&     Purpose of script
#& #&@     Other scripts or applications required to run
#& #&      General comment
#& #&%     Special comment Emphasized, Caution or Warning
#

rm -f /tmp/scripts_info_mpg

ls -1 * | egrep -v "(^reduce|^nmon(_|m|1|9)|^dmi|^scripts|^source|^R|\,v$|^$)" > /tmp/pn_scripts_ls

cat <<-jamjam > /tmp/scripts_info_mpg.htm
<HTML>
<HEAD> <TITLE>Power Navigator Scripts Information</TITLE> </HEAD>
<BODY>
<P align=LEFT>
<STRONG>Power Navigator Data Consolidation Script (powernav.tar.gz)</STRONG>
<BR>Go to <A HREF= "ftp://anonymous@216.207.99.78/powernav.tar.gz" >ftp powernav.tar.gz</A> to obtain the most recent copy.</A>  
<BR>Go to <A HREF= "ftp://anonymous@216.207.99.78" >ftp from mpginc.com</A> to obtain the most recent copy of all the scripts, applications or documents mentioned in this HTML.</A>  
<P><STRONG>Power Navigator Support </STRONG><BR>
<A HREF= "http://www.mpginc.com/" >http://www.mpginc.com</A><BR>
<BR>Email: <A HREF="mailto:support@mpginc.com">support@mpginc.com</A> | <A HREF="mailto:rwatson@mpginc.com">rwatson@mpginc.com</A>

<HR>

<TABLE BORDER=".1">
<TR>
<TD VALIGN="TOP">
<BR><STRONG>Go to information specifically for: </STRONG>
<BR><multicol cols=4>
jamjam

cat /tmp/pn_scripts_ls \
   |awk '{print "<A HREF=\"#"$0"\">"$0"</A><br>"}' >> /tmp/scripts_info_mpg.htm 

echo '</multicol>' >> /tmp/scripts_info_mpg.htm 


jcnt=0
while
read file
do
   print -n "."
   (( jcnt=$jcnt+1 ))
   if [ jcnt -eq 50 ]
   then
      # On each 50 scripts there will be a line break
      (( jcnt=0 ))
      print "" 
   fi
   # These provide the text file 
   echo "----File Name----"  >> /tmp/scripts_info_mpg
   echo "@@ ${file}"  >> /tmp/scripts_info_mpg
   echo "--Revision Info--"  >> /tmp/scripts_info_mpg
   grep "\$\I\d"  $file  >> /tmp/scripts_info_mpg
   echo "----Required-----"  >> /tmp/scripts_info_mpg
   egrep "(^|^\ *)\#\&\@"  $file  >> /tmp/scripts_info_mpg
   echo "--Mail Comments--"  >> /tmp/scripts_info_mpg
   egrep "(^|^\ *)\#\&"  $file  >> /tmp/scripts_info_mpg
   echo ""  >> /tmp/scripts_info_mpg
   echo ""  >> /tmp/scripts_info_mpg
   echo ""  >> /tmp/scripts_info_mpg
   
   # These provide the html doc 
   egrep "(^|\ *)\#\&" $file > /tmp/scripts_info_mpg_tmp
   echo "<TR>" >> /tmp/scripts_info_mpg.htm
   echo "<TD VALIGN=\"TOP\">" >> /tmp/scripts_info_mpg.htm
   echo "<P>" >> /tmp/scripts_info_mpg.htm
   echo "<BR><STRONG><A NAME=\"${file}\"><font color=\"#009000\">${file}</font></A></STRONG>" >> /tmp/scripts_info_mpg.htm

   # Add lines for script purpose or redline if missing
   egrep "(^|^\ *)\#\&\&" /tmp/scripts_info_mpg_tmp | awk '{print "<BR><STRONG>"substr($0,5)"</STRONG>"}'  > /tmp/scripts_info_mpg_tmp2
   if [ -s /tmp/scripts_info_mpg_tmp2 ]
   then
      cat /tmp/scripts_info_mpg_tmp2 >>  /tmp/scripts_info_mpg.htm
   else
      echo "<BR><STRONG><font color=\"#ff0000\">No Purpose Provided</font></STRONG>" >> /tmp/scripts_info_mpg.htm
   fi

   # Add lines for special comments if necessary
   egrep "(^|^\ *)\#\&\%" /tmp/scripts_info_mpg_tmp | awk '{print "<BR><STRONG><font color=purple>"substr($0,5)"</font></STRONG>"}'  > /tmp/scripts_info_mpg_tmp2
   if [ -s /tmp/scripts_info_mpg_tmp2 ]
   then
      cat /tmp/scripts_info_mpg_tmp2 >>  /tmp/scripts_info_mpg.htm
   fi

   # Add lines for required files if necessary
   egrep "(^|^\ *)\#\&\@" /tmp/scripts_info_mpg_tmp | awk '{print "<BR><STRONG><font color=blue>"substr($0,5)"</font></STRONG>"}'  > /tmp/scripts_info_mpg_tmp2
   if [ -s /tmp/scripts_info_mpg_tmp2 ]
   then
      cat /tmp/scripts_info_mpg_tmp2 >>  /tmp/scripts_info_mpg.htm
   fi

      # Jack test
   # Add all comment lines or redline if missing
   egrep "(^|^\ *)\#\&(\ |$)" /tmp/scripts_info_mpg_tmp | awk '{print "<BR>"substr($0,3)""}'  > /tmp/scripts_info_mpg_tmp2
   if [ -s /tmp/scripts_info_mpg_tmp2 ]
   then
      cat /tmp/scripts_info_mpg_tmp2  >>  /tmp/scripts_info_mpg.htm
   else
      echo "<BR><STRONG><font color=\"#ff0000\">No Regular Comments. There must be at least one (#&) </font></STRONG>" >> /tmp/scripts_info_mpg.htm
   fi

done < /tmp/pn_scripts_ls

print "" 

cat <<-jamjam >> /tmp/scripts_info_mpg.htm
</TABLE>
<HR>
</UL> 
<P><STRONG>Power Navigator Support </STRONG><BR>
<A HREF= "http://www.mpginc.com/" >http://www.mpginc.com</A><BR>
For quick support, click here or e-mail <BR>
Email: <A HREF="mailto:=support@mpginc.com">support@mpginc.com</A><BR>
Email2: <A HREF="mailto:=rwatson@mpginc.com">rwatson@mpginc.com</A><BR>
To Contact MPG: <BR>
100 Arapahoe Ave., Suite 14, Boulder, CO 80302 <BR>
Voice (800) 457-6744 or email rwatson@mpginc.com <BR>
--------------- <BR>
For international calls, 303-939-9648 <BR>
--------------- <BR>
<P><font size="-1">Copyright &copy;2004-2012 <a
href= "http://www.mpginc.com" >Midrange Performance Group, Inc.</a> All rights
reserved.<br></FONT>
</BODY>
</HTML>
jamjam

chmod 644 /tmp/scripts_info_mpg /tmp/scripts_info_mpg.htm

echo "All script information in text form is in /tmp/scripts_info_mpg"
echo "All script information in html form is in /tmp/scripts_info_mpg.htm"

#& =-=-=-=-=-=-=-=-=-=-=-=-=
#& Sample Run  
#& =-=-=-=-=-=-=-=-=-=-=-=-=
#& > pn_scripts_info_mpg.sh
#& Running pn_scripts_info_mpg.sh
#& ..................................................
#& ..........................
#& All script information in text form is in /tmp/scripts_info_mpg
#& All script information in html form is in /tmp/scripts_info_mpg.htm
