#!/bin/ksh
#
# $Id: pnedcp_snap.sh,v 1.17 2012/04/10 18:13:53 root Exp $
#
# The following code is Confidential and is covered by the installation license
# Copyright 2004-2012 by Midrange Performance Group
#
#&& Power Navigator External Data Collection Process (pnedcp_snap.sh)
#& This script runs at snap collection process.
#
# snapshot id #
nm_nmbr=$1

invocdir=`dirname $0`

# Load the configuration file for transfer_current_cmd variable
. ${invocdir}/pn.config
# Load the Power Navigator External Data Collection configuration options
. ${invocdir}/pnedcp.config

### set > pnedcp_snap_env.mpginc

if [ "$ext_data_collect" = "T" ] ; then
   # sleep may be necessary to ensure that nmon has finished writing it's date
   # sleep 10

   # It is assumed that the mpgdata2 file will already have logged this information so it can be placed in the mpgdata3 file.
   # egrep "^ZZZZ,$nm_nmbr," $nmf | sed s,ZZZZ,PNZZ,g  >> ${pnedcp_out} 
   egrep "^ZZZZ,$nm_nmbr," $nmf >> ${pnedcp_out} 

   # capture psid and uid into the nomn file at each snap.

  ps -edo  pid,ppid,uname,pcpu,pmem,vsz,args \
      | sort -n \
      | tee ./ps-ef.mpginc \
      | awk -v vszt="${vsz_threshold}" -v pcpu="${percent_cpu}" -v pmem="${percent_mem}" 'BEGIN { OFS="," } {if(( $3 != "<defunct>" && $3 != "root" && $3 != "daemon" && $3 != "pconsole") || ($4 > pcpu || $5 > pmem || $6 > vszt )) print "PS",$1,$2,$3,$4,$5,$6,substr($7" "$8" "$9" "$10" "$11" "$12" "$13,1,40)}' | sed s,\ *$,,  >>  ${pnedcp_out}

   # Initially gathered only process and username (not enough details)
   # ps -ef | awk '{print $2,$1}' | sort -n | awk 'BEGIN { OFS="," } {print "PS",$1,$2}'   TNO=$nm_nmbr >>  ${pnedcp_out}

   # There may be additional information that needs to be added to the snap, but not at the present.
   # Future enhancement, each type of snapshot may be configured via a configuration file.
fi

##################################
# mpgdata2_current.hostname process follows 
##################################
# Added a cat of all mpg_yyyymmdd.nmon that are newer than 0000 the day that cend.sh was ran, or today at 0000
# which ever is older.  Data is gathered into mpgdata2_current.hostname 
# The file last_cend is created by cend.sh script or the start_nmon_now script when necessary. 
# The file mpg_today is created by the start_nmon_now script.  

jdate=`date +%Y%m%d`
jtimetest=`find last_cend -newer mpg_today`
if [ "x${jtimetest}x" = "xx" ]; then
   Time_ref_file=last_cend
else
   Time_ref_file=mpg_today
fi
sync
find mpg_20[0-9][0-9][0-9][0-9][0-9][0-9].nmon mpg_20[0-9][0-9][0-9][0-9][0-9][0-9].nmon.[0-9][0-9] -newer $Time_ref_file \
   | xargs cat /tmp/mpgmpg 2>/dev/null >  ${pnedcp_current}

# If there is a transfer_current_cmd variable, and it has transfer_current.sh 
# in the variable, then run the transfer_current_cmd commmand.
if [ "x${transfer_current_cmd}x" != "xx" ] ; then
   echo ${transfer_current_cmd} | grep transfer_current.sh > /dev/null
   jchk=$? 
   if [ ${jchk} -eq 0 ] ; then
      ${transfer_current_cmd}
   fi
fi

