#!/bin/ksh
#
# $Id: pnedcp_start.sh,v 1.10 2012/02/14 04:33:34 root Exp root $
#
# The following code is Confidential and is covered by the installation license
# Copyright 2004-2012 by Midrange Performance Group
#
#&& Power Navigator External Data Collection Process (pnedcp_start.sh)
#& This script runs at the start of the collection process.
#

invocdir=`dirname $0`

# No variable in place in config currently.
# Load the Power Navigator External Data Collection configuration options
. ${invocdir}/pnedcp.config

# snapshot id #
nm_nmbr=$1

# Create the mpg file and comment with company name if it does not exist
if [ ! -s ${pnedcp_out} ]; then
   echo "# This file is used by Power Navigator from Midrange Performance Group, Inc. (MPG)" >> ${pnedcp_out} 
   echo "# for the external data collection process (pnedcp)." >> ${pnedcp_out} 
   echo "# For questions, please call 303-939-9648." >> ${pnedcp_out} 
fi

if [ "$ext_data_collect" = "T" ] ; then
   # It is assumed that the mpgdata2 file will already have logged this information so it can be placed in the mpgdata3 file.
   egrep "^AAA,(time|date|host|SerialNumber)," $nmf | sed s,AAA,MPG,g  >> ${pnedcp_out} 
fi

# There may be additional information that needs to be added at the start, but not at the present.

